#ifndef __ABC_ALPHABETA_H__
#define __ABC_ALPHABETA_H__



typedef struct { _iq Ua; //phase A voltage, input
			 	 _iq Ub; //phase B voltage, input
				 _iq Uc; //phase C voltage, input
//				 _iq Tetta; //phase angle, input
				 _iq Ualpha; // axis d voltage, output
			 	 _iq Ubeta; // axis q voltage, output
				 void (*calc)(); // Pointer to calculation function
				 }ABC_TO_ALPHABETA;





typedef ABC_TO_ALPHABETA *ABC_TO_ALPHABETA_handle;

#define ABC_TO_ALPHABETA_DEFAULTS { 0, \
						    0, \
						    0, \
						    0, \
						    0, \
						    (void (*)(unsigned long))abc_to_alphabeta_calc\
						    } 


void abc_to_alphabeta_calc(ABC_TO_ALPHABETA_handle);








#endif // end __ABC_ALPHABETA_H
