#ifndef __ALPHABETA_DQ_H__
#define __ALPHABETA_DQ_H__



typedef struct { _iq Ualpha; //phase A voltage, input
			 	 _iq Ubeta; //phase B voltage, input
				 _iq Tetta; //phase angle, input
				 _iq Ud; // axis d voltage, output
			 	 _iq Uq; // axis q voltage, output
				 void (*calc)(); // Pointer to calculation function
				 }ALPHABETA_TO_DQ;





typedef ALPHABETA_TO_DQ *ALPHABETA_TO_DQ_handle;

#define ALPHABETA_TO_DQ_DEFAULTS { 0, \
						    0, \
						    0, \
						    0, \
						    0, \
						    (void (*)(unsigned long))alphabeta_to_dq_calc \
						    } 


void alphabeta_to_dq_calc(ALPHABETA_TO_DQ_handle);


#endif // end __ALPHABETA_DQ_H
