/*
 * regul_power.h
 *
 *  Created on: 16 . 2020 .
 *      Author: star
 */

#ifndef SRC_VECTORCONTROL_NIO12_REGUL_POWER_H_
#define SRC_VECTORCONTROL_NIO12_REGUL_POWER_H_

#include "pid_reg3.h"

typedef struct {
    PIDREG3 pidP;
    _iq Pzad_rmp;
    _iq koef_fast;
    _iq koef_slow;
    _iq Iq_out_max;
    _iq Pnominal;
} POWER;

#define POWER_DEFAULTS {PIDREG3_DEFAULTS, 0,0,0,0,0}

_iq vector_power(_iq Pzad, _iq P_measured, int mode, unsigned int master,
        		_iq Iq_measured, _iq Iq_limit, _iq* Frot_zad, int reset);
void init_Pvect(void);

extern POWER power;

#endif /* SRC_VECTORCONTROL_NIO12_REGUL_POWER_H_ */
