/*
 * profile_interrupt.h
 *
 *  Created on: 6 . 2024 .
 *      Author: yura
 */

#ifndef SRC_N12_XILINX_PROFILE_INTERRUPT_H_
#define SRC_N12_XILINX_PROFILE_INTERRUPT_H_


typedef union {
 unsigned int all;
 struct {
     unsigned int timer1: 1;
     unsigned int timer2: 1;
     unsigned int timer3: 1;
     unsigned int timer4: 1;

     unsigned int sync: 1;
     unsigned int can: 1;
     unsigned int rsa: 1;
     unsigned int rsb: 1;

     unsigned int pwm: 1;
     unsigned int reserv: 7;
 } bits;
} t_enable_profile;




typedef struct
{
    t_enable_profile for_led1;
    t_enable_profile for_led2;

} t_profile_interrupt;

#define T_PROFILE_INTERRUPT_DEFAULT      {0,0}



extern t_profile_interrupt profile_interrupt;
void init_profile_interrupt(void);


#endif /* SRC_N12_XILINX_PROFILE_INTERRUPT_H_ */
