#ifndef XP_ID_PLATE_INFO_H
#define XP_ID_PLATE_INFO_H 	


#define PLATE_TYPE_RESERVED	1
#define PLATE_TYPE_IN	1
#define PLATE_TYPE_TK_ICEBREAKER	1
#define PLATE_TYPE_TK_BALZAM	1
#define PLATE_TYPE_ADC	1
#define PLATE_TYPE_TK_21300	1
#define PLATE_TYPE_TK_23550	1
#define PLATE_TYPE_OUT	1
#define PLATE_TYPE_TK_EDRK	1
#define PLATE_TYPE_ROT_SENSOR_PLATE	1


typedef enum {
	plate_type_undefined= 0,  
	plate_type_reserved,
	plate_type_IN,
	plate_type_TK_ICEBREAKER = 5,
	plate_type_TK_BALZAM,
	plate_type_ADC,
	plate_type_TK_21300 = 9,
	plate_type_TK_23550 = 10,
	plate_type_OUT = 11,
	plate_type_TK_EDRK = 13,
	plate_type_ROT_SENSOR_PLATE = 14
} T_plate_type;

/*

"BITS (15:11) - plate type 
0 -undefined, 
1-RESERVED
2-IN
3-RESERVED
4-RESERVED
5-TK-ICEBREAKER
6-TK-BALZAM
7-ADC
8-RESERVED
9-TK-21300(2 LEVEL INV STANDART_TYPE)
10-TK-23550(BALSAM Modification with optics serial interface)
11-OUT
12-RESERVED
13-TK_EDRK
14-ROT_SENSOR_PLATE
15-to 31 RESERVED

BITS (10:5) -Version
0-UNDEFINED  ,   51,   =     50

BITS (4:0) - Revision
0-UNDEFINED, 1- A, 2-B.. 26-Z
"
*/





/*------------------------------------------------------------------------------
 Plane counter
------------------------------------------------------------------------------*/


#endif  // end XP_ID_PLATE_INFO_H



