/*
 * alg_uf_const.h
 *
 *  Created on: 26 . 2020 .
 *      Author: Yura
 */

#ifndef SRC_MAIN_ALG_UF_CONST_H_
#define SRC_MAIN_ALG_UF_CONST_H_


#include "IQmathLib.h"
#include "rmp_cntl_v1.h"


typedef struct  {
    RMP_V1 rmp_freq;
    _iq freq;
    _iq km;
    _iq zad_plus_km;
    _iq max_km;
} ALG_UF_CONST;

extern ALG_UF_CONST uf_const1;

#define ALG_UF_CONST_DEFAULT   {RMP_V1_DEFAULTS, 0, 0, 0, 0 }




void init_uf_const(void);
void uf_const(_iq *Fz, _iq *Uz1, _iq *Uz2);

#endif /* SRC_MAIN_ALG_UF_CONST_H_ */
