#ifndef REGUL_TURNS
#define REGUL_TURNS
#include "IQmathLib.h"
#include "pid_reg3.h"

typedef struct {
    PIDREG3 pidFvect;

    _iq Fzad_rmp;
    _iq Fnominal;
    _iq koef_fast;
    _iq koef_slow;
    _iq Iq_out_max;
    _iq Id_out_max;
    _iq mzz_zad_int;
} TURNS;

#define TURNS_DEFAULTS {PIDREG3_DEFAULTS, 0,0,0,0,0,0,0}

void init_Fvect(void);
void vector_turns(_iq Fzad, _iq Frot,
                  _iq Iq, _iq Iq_limit, int mode,
				  unsigned int master, _iq *Iq_zad, int reset);

extern TURNS turns;

#endif //REGUL_TURNS


