/*
 * can_protocol_ukss.h
 *
 *  Created on: 23 . 2024 .
 *      Author: yura
 */

#ifndef SRC_MAIN_CAN_PROTOCOL_UKSS_H_
#define SRC_MAIN_CAN_PROTOCOL_UKSS_H_



#define CAN_PROTOCOL_UKSS   2 // 2


#ifndef CAN_PROTOCOL_UKSS
#define CAN_PROTOCOL_UKSS   1
#endif




#if (CAN_PROTOCOL_UKSS == 2)


#define ADR_CYCLES_TIMER_MAIN       96     // .  CAN, * 10 m
#define ADR_CYCLES_TIMER_ADD        97     // .  CAN, * 10 m
#define ADR_CYCLES_PAUSE_MAIN       98     // .  CAN, * 10 m
#define ADR_CYCLES_PAUSE_ADD        99     // .  CAN, * 10 m
#define ADR_CYCLES_REPEATE_MAIN     100     // .  CAN, * 10 m
#define ADR_CYCLES_REPEATE_ADD      101     // .  CAN, * 10 m
#define ADR_CYCLES_REPEATE_DIGIO       102     //  . , 

#define ADR_LIGHT_LED_1       104     //  1
#define ADR_LIGHT_LED_2       105     //  2
#define ADR_LIGHT_LED_3       106     //  3
#define ADR_LIGHT_LED_4       107     //  4
#define ADR_LIGHT_LED_5       108     //  5
#define ADR_LIGHT_LED_6       109     //  6
#define ADR_LIGHT_LED_7       110     //  7



#define ADR_COUNT_CYCLES_MAIN       120     //  .  CAN
#define ADR_COUNT_CYCLES_ADD        121     //  .  CAN
#define ADR_COUNT_FULL_CYCLES_MAIN  122     //-   .  CAN
#define ADR_COUNT_FULL_CYCLES_ADD   123     //-   .  CAN

#define ADR_PROTOCOL_VERSION        125         // 
#define ADR_UKSS_NUMBER             126         // 

#endif










#endif /* SRC_MAIN_CAN_PROTOCOL_UKSS_H_ */
