/*
 * params_motor.h
 *
 *  Created on: 14 . 2020 .
 *      Author: yura
 */

#ifndef SRC_MAIN_PARAMS_MOTOR_H_
#define SRC_MAIN_PARAMS_MOTOR_H_



#define SDVIG_OBMOTKI_ZERO      1
#define SDVIG_OBMOTKI_30_PLUS   2
#define SDVIG_OBMOTKI_30_MINUS  3


#define SETUP_SDVIG_OBMOTKI SDVIG_OBMOTKI_ZERO //SDVIG_OBMOTKI_ZERO
//#define SETUP_SDVIG_OBMOTKI SDVIG_OBMOTKI_30_PLUS //SDVIG_OBMOTKI_ZERO

#define COS_FI 0.87
// Level of nominal currents
#define I_OUT_NOMINAL_IQ        5033164// 900 A        //8388608 ~ 1500A //5592405 ~ 1000A // 10066329 ~ 1800A
                                        //11184811 ~ 2000A // 12482249 ~ 2232A // 6710886 ~ 1200A
#define I_OUT_NOMINAL   900

#define MOTOR_CURRENT_NOMINAL   650.0   //930.0
#define MOTOR_CURRENT_MAX       900.00 //1489.0




#define P_NOMINAL   6300    //KWt
#define WROT_NOMINAL 180.0
#define WROT_MAX   530.0
#define FROT_NOMINAL (WROT_NOMINAL / 60.0)
#define FROT_MAX   (WROT_MAX / 60.0)

//#define REVERS_ON_CLOCK   1 // 0 //  1-   .. 0 -  



//#define WORK_TWICE 0         /*   y  */


//#define MAX_ZAD_OBOROTS     200

#define L_SIGMA_S   0.0001467
#define L_SIGMA_R   0.00000923
#define L_M         0.00421
#define R_STATOR    0.002
#define R_ROTOR_SHTRIH     0.0021
#define SLIP_NOM    0.006
#define R_ROTOR     (R_ROTOR_SHTRIH / SLIP_NOM)
#define F_STATOR_NOM 50.0



#endif /* SRC_MAIN_PARAMS_MOTOR_H_ */
