#ifndef __ALPHABETA_ABC_H__
#define __ALPHABETA_ABC_H__

#include "IQmathLib.h"

typedef struct { _iq Ualpha; // axis d voltage, output
			 	 _iq Ubeta; // axis q voltage, output
				 _iq Ua; //phase A voltage, input
			 	 _iq Ub; //phase B voltage, input
				 _iq Uc; //phase C voltage, input
				 void (*calc)(); // Pointer to calculation function
				 }ALPHABETA_TO_ABC;





typedef ALPHABETA_TO_ABC *ALPHABETA_TO_ABC_handle;

#define ALPHABETA_TO_ABC_DEFAULTS{ 0, \
						    0, \
						    0, \
						    0, \
						    0, \
						    (void (*)(Uint32))alphabeta_to_abc_calc\
						    } 


void alphabeta_to_abc_calc(ALPHABETA_TO_ABC_handle);








#endif // end __ALPHABETA_ABC_H__
