/*
 * detect_phase_break.h
 *
 *  Created on: 10 . 2020 .
 *      Author: star
 */

#ifndef SRC_MAIN_DETECT_PHASE_BREAK_H_
#define SRC_MAIN_DETECT_PHASE_BREAK_H_

typedef struct {
    _iq iqIu;
    _iq iqIv;
    _iq iqIw;
    _iq iqImod;
    _iq teta;
    _iq prev_teta;

    _iq latched_teta[3];
    int latch_break_start[3];

    struct {
        _iq iqLevelZero;

    } config;

    int (*calc)();
} BREAK_PHASE_I;

#define BREAK_PHASE_I_DEFAULTS {0,0,0,0,0,0, \
                        {0,0,0}, {0,0,0}, {0}, \
                        calc_break_I_phase }

int calc_break_I_phase(BREAK_PHASE_I *v);

#endif /* SRC_MAIN_DETECT_PHASE_BREAK_H_ */
