#ifndef PROJECT_H
#define PROJECT_H


#include "DSP281x_Examples.h"   // DSP281x Examples Include File
#include "DSP281x_GlobalPrototypes.h"
#include "DSP281x_SWPrioritizedIsrLevels.h"   // DSP281x Examples Include File
#include "DSP281x_Device.h"
#include "DSP281x_Ev.h"   // DSP281x Examples Include File
#include "MemoryFunctions.h"
#include "Spartan2E_Adr.h"
#include "Spartan2E_Functions.h"
#include "TuneUpPlane.h"
#include "x_parallel_bus.h"
#include "x_serial_bus.h"
#include "xerror.h"
#include "xp_adc.h"
#include "xp_cds_in.h"
#include "xp_cds_out.h"
#include "xp_cds_tk.h"
#include "xp_controller.h"
#include "xp_hwp.h"
#include "xp_project.h"
#include "xPeriphSP6_loader.h"
//#include "xp_omega.h"
//#include "xp_dispatcher.h"

//#include "x_error_buffer.h"

//#include "x_project_plane.h"

/* Define this macros to add to project files, contaning code  */
/* communicating with test terminal by RS232                      */
#define USE_TEST_TERMINAL 1	

/* Define this macros to add to project files, contaning code  */
/* communicating with SVO and MPU by RS, using modbus protokol */
#define USE_MODBUS_TABLE_SVU    1

/* Define this macros to add to project files, contaning code  */
/* communicating with Ingeteam Pult by RS, using modbus protocol */
#define USE_MODBUS_TABLE_PULT    1


//  control_station.c  control_station.h
#define USE_CONTROL_STATION     1





/////////////////////////////////////////////////////////////////
#ifndef USE_CONTROL_STATION
#define USE_CONTROL_STATION 0
#endif

#ifndef USE_TEST_TERMINAL
#define USE_TEST_TERMINAL 0
#endif

#ifndef USE_MODBUS_TABLE_SVU
#define USE_MODBUS_TABLE_SVU 0
#endif

#ifndef USE_MODBUS_TABLE_PULT
#define USE_MODBUS_TABLE_PULT 0
#endif
////////////////////////////////////////////////////////////////
//    .   HWP
////////////////////////////////////////////////////////////////
void project_prepare_config(void);


#endif // end PROJECT_H
